package io.accumulatenetwork.sdk.generated.query;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import io.accumulatenetwork.sdk.generated.managed.ChainType;
import io.accumulatenetwork.sdk.protocol.Marshallable;
import io.accumulatenetwork.sdk.support.Marshaller;
import io.accumulatenetwork.sdk.support.serializers.Hex2DDeserializer;
import io.accumulatenetwork.sdk.support.serializers.Hex2DSerializer;
// UnionType: 
// UnionValue: 

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("ResponseChainRange")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class ResponseChainRange implements Marshallable {
	private ChainType type;
	private int start;
	private int end;
	private int total;
	private byte[][] entries;

    //
	public ChainType getType() {
	    return type;
	}
	public void setType(final ChainType value) {
	    this.type = value;
	}

	public ResponseChainRange type(final ChainType value) {
	    setType(value);
	    return this;
	}
	public int getStart() {
	    return start;
	}
	public void setStart(final int value) {
	    this.start = value;
	}

	public ResponseChainRange start(final int value) {
	    setStart(value);
	    return this;
	}
	public int getEnd() {
	    return end;
	}
	public void setEnd(final int value) {
	    this.end = value;
	}

	public ResponseChainRange end(final int value) {
	    setEnd(value);
	    return this;
	}
	public int getTotal() {
	    return total;
	}
	public void setTotal(final int value) {
	    this.total = value;
	}

	public ResponseChainRange total(final int value) {
	    setTotal(value);
	    return this;
	}
	@JsonDeserialize(using = Hex2DDeserializer.class)
	public byte[][] getEntries() {
	    return entries;
	}
	@JsonSerialize(using = Hex2DSerializer.class)
	public void setEntries(final byte[][] value) {
	    this.entries = value;
	}

	public ResponseChainRange entries(final byte[][] value) {
	    setEntries(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        if (!(this.type == null)) {
            marshaller.writeValue(1, type);
        }
        marshaller.writeInt(2, this.start);
        marshaller.writeInt(3, this.end);
        marshaller.writeInt(4, this.total);
        if (!(this.entries == null || this.entries.length == 0)) {
            marshaller.writeBytes(5, this.entries);
        }
        return marshaller.array();
    }
}
